#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND TESTED IN A WINDOWS ENVIRONMENT ONLY AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
#    Name:	Panelization
#      By:	sdmitch
#   Usage:	To add and shape components/groups to a surface either over the surface as a whole or
#						or in each "quad" face of the surface mesh.
#		 Note:	The surface must be a group also.  Keep the panel component/group as simple as possible.
#						The mesh CAN NOT be a Triangulated Irregular Network(TIN)!  Regular newtworks ONLY!
#    Date:	Nov 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
module SDM

	class Panelization
	
		@@typ=nil;@@gap=nil
		
		def initialize
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@sel=@mod.selection
			@ip=Sketchup::InputPoint.new
			@@typ = "Faces" unless @@typ
			@pq = "Lo" unless @pq
			@@gap = 1.to_l unless @@gap
			self.reset
		end
		
		def reset
			@status = 0
			@sel.clear
			@status_text = "Wähle Oberflächen Gruppe"
			val=inputbox(["  Füllung an:","Füllung Abstand:"],[@@typ,@@gap],["Flächen|Oberflächen"],"Füllen")
			if !val
				onCancel(nil,nil)
			else
				@@typ=val[0]; @@gap=val[1]
				if @@typ=="Surface"
					qual=inputbox(["Qualität:"],["Normal"],["Normal|Hoch"],"Füllungs Qualität")
					if !qual
						onCancel(nil,nil)
					else
						@pq = qual[0]
					end
				end
			end
		end
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh
			Sketchup::set_status_text @status_text
		end
		
		def onLButtonDown(flags, x, y, view)
			ph = view.pick_helper; ph.do_pick x,y; best=ph.best_picked
			if @status==0
				if [Sketchup::Group,Sketchup::ComponentInstance].include?(best.class)
					@surface=best; @sel.add @surface; @trans=best.transformation
					@status=1;@status_text="Wähle Füllung Gruppe"
				else
					UI.beep
				end
			elsif @status==1
				if [Sketchup::Group,Sketchup::ComponentInstance].include?(best.class)
					@sel.add best
					@mod.start_operation "Panelization"
					@surface.transform! @trans.inverse
					case @@typ
						when "Faces" then self.on_Faces(best,@surface,@@gap)
						when "Surface" then self.on_Surface(best,@surface,@pq,@@gap)
					end
					@surface.transform! @trans
					@mod.definitions.purge_unused
					@mod.commit_operation
					self.reset
				else
					UI.beep
				end
			end
		end
		
		def onRButtonDown(flags, x, y, view)
			@status==0 ? onCancel(flags,view) : self.reset
		end
		
		def onCancel(flags,view)
			Sketchup.send_action "selectSelectionTool:"
		end
		 
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
		end
#
########################################################################
#
		def on_Surface(panel,surface,quality,gap)
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			if panel.class==Sketchup::Group
				new_panel = panel.copy
				comp_p=new_panel.to_component; 
			else
				comp_p = ent.add_instance(panel.definition,Geom::Transformation.new())
				comp_p.make_unique
			end
			comp_d=comp_p.definition
			#create a 'sub-divided' panel
			quality=="Hi" ? many=4 : many=2
			self.divide_entity(comp_p,many)
			inc_x=comp_d.bounds.width+gap;
			inc_y=comp_d.bounds.height+gap;
			min_z=surface.bounds.min.z - 2.0.to_l
			s_wid = surface.bounds.width
			s_hgt = surface.bounds.height
			n_col = (s_wid/inc_x).floor
			n_row = (s_hgt/inc_y).floor
			s_org=surface.bounds.min; #puts "s_org=#{s_org}"
			r_org=Geom::Point3d.new(s_org.x + gap/2.0, s_org.y + gap/2.0,min_z)
			cip = r_org.clone; #ent.add_cpoint(cip)
			vx=Geom::Vector3d.new(inc_x,0,0)
			tvx=Geom::Transformation.new(vx)
			vy=Geom::Vector3d.new(0,inc_y,0)
			grp=ent.add_group;gents=grp.entities;comps=[]
			1.upto(n_row) do |y|
				1.upto(n_col) do |x|
					Sketchup::set_status_text "Berrechne Reihe #{y}, col #{x}"
					comp=gents.add_instance(comp_d,Geom::Transformation.new(cip));
					comp.make_unique; comps<<comp
					cip.transform! tvx; #ent.add_cpoint(cip)
				end
				r_org.offset!(vy); cip = r_org.clone; #ent.add_cpoint(cip)
			end
			nxtc="1"; last=comps.length
			for comp in comps
				Sketchup::set_status_text "Berrechne Füllung #{nxtc} von #{last}"; nxtc=nxtc.next
				self.drop_panel(comp)
				comp.definition.entities.each{|e| e.soft=true if e.class==Sketchup::Edge && e.faces.length==2 && \
					e.faces[0].normal.angle_between(e.faces[1].normal)< 15.degrees}
				comp.explode
			end
			comp_p.erase!; grp.transform! @trans
		end
	#
	#####################################################################################
	#
		def on_Faces(panel,surface,gap)
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			if panel.class==Sketchup::Group
				new_panel = panel.copy
				comp_p=new_panel.to_component; 
			else
				comp_p = ent.add_instance(panel.definition,Geom::Transformation.new())
				comp_p.make_unique
			end
			comp_d=comp_p.definition; tran = surface.transformation
			# collect and process each face of the surface
			surface.class==Sketchup::Group ? ents=surface.entities : ents=surface.definition.entities
			faces=ents.select{|e| e.is_a?(Sketchup::Face)}
			cdx=comp_d.bounds.max.x-comp_d.bounds.min.x
			cdy=comp_d.bounds.max.y-comp_d.bounds.min.y
			tro=Geom::Transformation.new([-cdx/2.0,-cdy/2.0,0])
			comp_d.entities.transform_entities(tro,comp_d.entities.to_a)
			hyp=nil;pt=[];ciz = surface.bounds.min.z - 6.0.to_l
			grp=ent.add_group;gents=grp.entities;comps=[]
			for face in faces
				edges=face.outer_loop.edges;
				if edges.length == 3#tri face ######################################
					hyp=edges[0];
					for i in 1...edges.length
						hyp = edges[i] if hyp.length < edges[i].length
					end
					pt[0]=hyp.bounds.center
					edges.delete_if{|e| e == hyp}
					pt[1]=hyp.start.position;
					pt[2]=Geom.intersect_line_line(edges[0].line,edges[1].line);
					pt[3]=hyp.end.position;
					xdist=pt[2].distance(pt[1])-gap#*2.0;
					ydist=pt[2].distance(pt[3])-gap#*2.0
					xscl=xdist/cdx;yscl=ydist/cdy
					xaxis1=pt[1].vector_to(pt[2]).normalize;yaxis1=pt[3].vector_to(pt[2]).normalize
					if xaxis1.y.abs > xaxis1.x.abs then
						xscl=ydist/cdx;yscl=xdist/cdy
					end
					hyp_faces=hyp.faces
					hyp_faces.delete_if{|f| f == face}
					hyp_face=hyp_faces[0]
					pt0 = pt[0].transform surface.transformation; pt0.z =ciz
					tr=Geom::Transformation.new(pt0)
					ci=gents.add_instance(comp_d,tr);ci.make_unique
					tr=Geom::Transformation.scaling(pt0,xscl,yscl,1.0)
					ci.transform! tr; comps<<ci
					faces.delete_if{|f| f==hyp_face}
				elsif edges.length == 4# quad face ###################################
					pt[0]=face.bounds.center;#
					xdist=edges[1].length-gap;
					ydist=edges[0].length-gap;
					vec = face.normal.transform surface.transformation
					xscl=xdist/cdx
					yscl=ydist/cdy
					vec.z.abs < 0.5 ?  rotate=false : rotate=true
					tr=Geom::Transformation.new()
					ci=gents.add_instance(comp_d,tr)
					tr=Geom::Transformation.scaling(ORIGIN,xscl,yscl,1.0)
					ci.transform! tr
					if rotate
						tr=Geom::Transformation.new(ORIGIN,Z_AXIS,90.degrees)
						ci.transform! tr
					end
					pt0 = pt[0].transform surface.transformation
					tr=Geom::Transformation.new(pt0,vec)
					ci.transform! tr; ci.explode
				end
			end
			for comp in comps
				self.drop_panel(comp)
				comp.definition.entities.each{|e| e.soft=true if e.class==Sketchup::Edge && e.faces.length==2 && \
					e.faces[0].normal.angle_between(e.faces[1].normal)< 10.degrees}
				comp.explode
			end
			comp_p.erase!; grp.transform! @trans
		end
	#
	########################################################################
	#
		def drop_panel(corg)
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			btmz=corg.bounds.max.z;tran=corg.transformation;
			corg.class==Sketchup::Group ? ents=corg.entities : ents=corg.definition.entities
			p_verts=[]; p_vects=[]
			ents.each{|e| p_verts<<e.vertices}
			p_verts.flatten!; p_verts.uniq!
			p_verts.each{|v|
				p = v.position;sp=p.transform tran;
				spz=sp.z;sp.z=btmz;up_vec=Geom::Vector3d.new(0,0,1); 
				hit=mod.raytest([sp,up_vec])
				if hit
					if hit[1][-1].class==Sketchup::Face
						up_vec = hit[1][-1].normal 
						up_vec.reverse! if up_vec.z < 0
					end
					btm=hit[0].offset(up_vec,p.z) # calculate the reflected position
					sp.z=spz;p_vects<<sp.vector_to(btm)
				else
					p_vects<<Geom::Vector3d.new(0,0,2+spz); #puts "miss from #{sp}"
				end
			}
			begin
				ents.transform_by_vectors(p_verts,p_vects)
			rescue
				puts "Fehler"
			end
		end
	#
	########################################################################
	#
		def divide_entity(corg,many)
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			cor=[];facx=[];facy=[]; many=[many,2].max
			for i in 0..7
				cor[i]=corg.bounds.corner(i)
			end
			wid = corg.bounds.width;wid = [wid,0.1].max
			hgt = corg.bounds.height;hgt = [hgt,0.1].max
			dep = corg.bounds.depth;dep = [dep,0.1].max
			chop=ent.add_group;cex=chop.entities
			dx=wid/many.to_f;dy=hgt/many.to_f;dz=dep/many.to_f
			vx=Geom::Vector3d.new(dx,0,0)
			vy=Geom::Vector3d.new(0,dy,0)
			vz=Geom::Vector3d.new(0,0,dz)
			facx[0]=cor[0].clone.offset(vy.reverse).offset(vz.reverse)
			facx[1]=cor[2].clone.offset(vy).offset(vz.reverse)
			facx[2]=cor[6].clone.offset(vy).offset(vz)
			facx[3]=cor[4].clone.offset(vy.reverse).offset(vz)
			tr=Geom::Transformation.new(vx)
			1.upto(many-1) do
				facx.each{|p| p.transform! tr}
				face=cex.add_face(facx)
			end
			facy[0]=cor[0].clone.offset(vx.reverse).offset(vz.reverse)
			facy[1]=cor[4].clone.offset(vx.reverse).offset(vz)
			facy[2]=cor[5].clone.offset(vx).offset(vz)
			facy[3]=cor[1].clone.offset(vx).offset(vz.reverse)
			tr=Geom::Transformation.new(vy)
			1.upto(many-1) do
				facy.each{|p| p.transform! tr}
				face=cex.add_face(facy)
			end
			corg.class==Sketchup::Group ? ents=corg.entities : ents=corg.definition.entities
			cex.intersect_with(true,chop.transformation,ents,corg.transformation,false,corg)
			chop.erase!
		end
		
	end# of class
		
end
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("Werkzeuge von sdmitch")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Kanten und Linien")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Flächen Werkzeuge")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("Gruppen und Komponenten")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Diverse Werkzeuge")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Füllungen") { Sketchup.active_model.select_tool SDM::Panelization.new }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
